;SLN_PIPING.lsp revision 2.0.4.3A1
;
;revision 1.0.1 - revised dimension format, allowing changes for each selection.
;originally only one format.
;Revision 2.0.0 - LRE90 added
;Revision 2.0.1 - LRE45 added
;Revision 2.0.2 - Equal Tee's added.
;Revision 2.0.3 - Reducing Tee's added.
;Revision 2.0.4 - Pipe added
; 
  ;----------------------------------------------------------------------;
  ;----------------------------------------------------------------------;     
  ;----------------------------------------------------------------------;
 (defun ERR (MSG)
  (if (or (/= MSG "Function cancelled")
  ; If an error (such as ESC) occurs
          (= MSG "quit / exit abort")
      ) ;_ end of or
    (princ)
    (princ (strcat "\nError: " MSG))
  ) ; while this command is active...
  (setvar "OSMODE" OS) ; Restore saved modes
  (setq *ERROR* OLDERR) ; Restore old *error* handler
  (princ)
) ;end ERR 
  ;---------------------------DEFUN STATEMENTS--------------------------;
	(defun RESET_LIST ()
;	(start_list "mylist1" 3)   ; The 3 means we want to delete the old contents and start  	
	(start_list "get_size" 3)(end_list)
	);end reset_list
		
;-----------------------------DIALOGUE TOGGLES----------------------------; 
	(defun L1_ON ()
     (mode_tile "rb1" 0)
	 (mode_tile "rb2" 0)
	 (mode_tile "rb3" 0)
	 (mode_tile "rb4" 0)
;	 (mode_tile "rb5" 0)
;	 (mode_tile "rb6" 0)
;	 (mode_tile "rb7" 0)
	)	
	(defun L1_OFF ()
     (mode_tile "rb1" 1)
	 (mode_tile "rb2" 1)
	 (mode_tile "rb3" 1)
	 (mode_tile "rb4" 1)
	 (mode_tile "rb5" 1)
	 (mode_tile "rb6" 1)
	 (mode_tile "rb7" 1)
	)
;-----------------------------------------------------------------------;	
	(defun L2_ON ()
	 (mode_tile "rb11" 0)
	 (mode_tile "rb12" 0)
	 (mode_tile "rb13" 0)
	 (mode_tile "rb14" 0)
	 (mode_tile "rb15" 0)
	)	
	(defun L2_OFF ()
	 (mode_tile "rb11" 1)
	 (mode_tile "rb12" 1)
	 (mode_tile "rb13" 1)
	 (mode_tile "rb14" 1)
	 (mode_tile "rb15" 1)
	)
;-----------------------------------------------------------------------;
	(defun L3_ON ()
	 (mode_tile "rb21" 0)
	 (mode_tile "rb22" 0)
	 (mode_tile "rb23" 0)
	)	
	(defun L3_OFF ()
	 (mode_tile "rb21" 1)
	 (mode_tile "rb22" 1)
	 (mode_tile "rb23" 1)
	)
;-----------------------------------------------------------------------;
	(defun L4_ON ()
	 (mode_tile "rb31" 0)
	 (mode_tile "rb32" 0)
	 (mode_tile "rb33" 0)
	 (mode_tile "rb34" 0)
	 (mode_tile "rb35" 0)
	 (mode_tile "rb36" 0)
	 (mode_tile "rb37" 0)
	)
	(defun L4_SCR_ON ()
	 (mode_tile "rb31" 0)
	 (mode_tile "rb32" 0)
	 (mode_tile "rb33" 0)
	 (mode_tile "rb34" 0)
	 (mode_tile "rb35" 0)
	 (mode_tile "rb36" 0)
	)
	(defun L4_SW_ON ()
	 (mode_tile "rb31" 0)
	 (mode_tile "rb32" 0)
	 (mode_tile "rb33" 0)
	 (mode_tile "rb34" 0)
	 (mode_tile "rb35" 0)
	 (mode_tile "rb36" 0)
	)	
	(defun L4_OFF ()
	 (mode_tile "rb31" 1)
	 (mode_tile "rb32" 1)
	 (mode_tile "rb33" 1)
	 (mode_tile "rb34" 1)
	 (mode_tile "rb35" 1)
	 (mode_tile "rb36" 1)
	 (mode_tile "rb37" 1)
	)
;-----------------------------------------------------------------------;
	(defun L5_ON ()
	 (mode_tile "rb41" 0)
	 (mode_tile "rb42" 0)
	 (mode_tile "rb43" 0)
	 (mode_tile "rb44" 0)
	 (mode_tile "rb45" 0)
	 (mode_tile "rb46" 0)
	 (mode_tile "rb47" 0)
	 (mode_tile "rb48" 0)
	 (mode_tile "rb49" 0)
	)
	(defun L5_FITTINGS_ON ()
;	 (mode_tile "rb41" 0)
	 (mode_tile "rb42" 0)
	 (mode_tile "rb43" 0)
	 (mode_tile "rb44" 0)
	 (mode_tile "rb45" 0)
	 (mode_tile "rb46" 0)
	 (mode_tile "rb47" 0)
	 (mode_tile "rb48" 0)
	 (mode_tile "rb49" 0)
	)	
	(defun L5_SW_ON ()
	 (mode_tile "rb42" 0)
;	 (mode_tile "rb43" 0)
	 (mode_tile "rb44" 0)
	 (mode_tile "rb45" 0)
;	 (mode_tile "rb46" 0)
	 (mode_tile "rb47" 0)
;	 (mode_tile "rb48" 0)
	)	
	(defun L5_OFF ()
	 (mode_tile "rb41" 1)
	 (mode_tile "rb42" 1)
	 (mode_tile "rb43" 1)
	 (mode_tile "rb44" 1)
	 (mode_tile "rb45" 1)
	 (mode_tile "rb46" 1)
	 (mode_tile "rb47" 1)
	 (mode_tile "rb48" 1)
	 (mode_tile "rb49" 1)
	)
;-----------------------------------------------------------------------;
	(defun L1_CLEAR ()
	 (set_tile "rb1" "0")
	 (set_tile "rb2" "0")
	 (set_tile "rb3" "0")
	 (set_tile "rb4" "0")
	 (set_tile "rb5" "0")
	 (set_tile "rb6" "0")
	 (set_tile "rb7" "0")
	)	
	(defun L2_CLEAR ()
	 (set_tile "rb11" "0")
	 (set_tile "rb12" "0")
	 (set_tile "rb13" "0")
	 (set_tile "rb14" "0")
	 (set_tile "rb15" "0")
	)	
	(defun L3_CLEAR ()
	 (set_tile "rb21" "0")
	 (set_tile "rb22" "0")
	 (set_tile "rb23" "0")
	)	
	(defun L4_CLEAR ()
	 (set_tile "rb31" "0")
	 (set_tile "rb32" "0")
	 (set_tile "rb33" "0")
	 (set_tile "rb34" "0")
	 (set_tile "rb35" "0")
	 (set_tile "rb36" "0")
	 (set_tile "rb37" "0")	
	)		
	(defun L5_CLEAR ()
	 (set_tile "rb41" "0")
	 (set_tile "rb42" "0")
	 (set_tile "rb43" "0")
	 (set_tile "rb44" "0")
	 (set_tile "rb45" "0")
	 (set_tile "rb46" "0")
	 (set_tile "rb47" "0")
	 (set_tile "rb48" "0")
	 (set_tile "rb49" "0")
	)
;------------------------------------------------------------------------------------;
;-----------------------------------------RADIO BUTTONS------------------------------;	
	(defun RB1_FLAG ()
	(set_tile "labeln1" "C/L Radius   A:")
	(set_tile "labeln2" "Wall Thk      t:")
;	(set_tile "labeln3" "N/A.           :")
;	(set_tile "labeln4" "N/A.           :")
;	(set_tile "labeln5" "N/A.           :")
	(set_tile "labeln6" "Elbow O/D      :")
;	(set_tile "labeln7" "N/A.           :")
	(set_tile "labeln8" "Kg             :")
	(set_tile "labeln9" "Bore I/D       B:")
;	(set_tile "labeln10" "N/A.          :")
	(setq ftg "lre90_")										;store fitting type	
	);end rb1_flag	
	
	(defun RB2_FLAG ()
	(set_tile "labeln1" "C/L Radius   A:")
	(set_tile "labeln2" "Wall Thk      t:")
;	(set_tile "labeln3" "N/A.           :")
;	(set_tile "labeln4" "N/A.           :")
;	(set_tile "labeln5" "N/A.           :")
	(set_tile "labeln6" "Elbow O/D   D:")
	(set_tile "labeln7" "Centre - End B :")
	(set_tile "labeln8" "Kg             :")
	(set_tile "labeln9" "Bore I/D       :")
;	(set_tile "labeln10" "N/A.          :")
	(setq ftg "lre45_")										;store fitting type
	);end rb2_flag	
	
	(defun RB3_FLAG ()
	(set_tile "labeln1" "O/L Length  A:")
	(set_tile "labeln2" "Wall Thk        t:")
	(set_tile "labeln3" "Centre - End M:")
;	(set_tile "labeln4" "N/A.           :")
;	(set_tile "labeln5" "N/A.           :")
	(set_tile "labeln6" "Tee O/D       D:")
	(set_tile "labeln7" "Centre - End  C:")
	(set_tile "labeln8" "Kg             :")
	(set_tile "labeln9" "Bore I/D       B:")
;	(set_tile "labeln10" "N/A.          :")
	(setq ftg "et_")										;store fitting type
	);end rb3_flag		

	(defun RB4_FLAG ()
	(set_tile "labeln1" "O/L Length   A:")
	(set_tile "labeln2" "Run Wall     t1:")
	(set_tile "labeln3" "Centre - End M:")
	(set_tile "labeln4" "Branch Wall  t2:")
	(set_tile "labeln5" "Branch I/D B2:")
	(set_tile "labeln6" "Run O/D     D1:")
	(set_tile "labeln7" "Centre - End  C:")
	(set_tile "labeln8" "Kg             :")
	(set_tile "labeln9" "Run I/D       B1:")
	(set_tile "labeln10" "Branch O/D D2:")
	(setq ftg "rt_")										;store fitting type
	);end rb4_flag	

	(defun RB5_FLAG ()
	(setq ftg "cr_")										;store flange type
	);end rb5_flag	

	(defun RB6_FLAG ()
	(setq ftg "er_")										;store flange type
	);end rb6_flag	

	(defun RB7_FLAG ()
	(setq ftg "ec_")										;store flange type
	);end rb7_flag	

	(defun RB11_FLAG ()
	(setq flg "wn_")										;store flange type
	(set_tile "labeln1" "Flange O/D   O:")
	(set_tile "labeln2" "Flange Thk   C:")
	(set_tile "labeln3" "Face Dia.     R:")
	(set_tile "labeln4" "Stud Qty.     :")
	(set_tile "labeln5" "Stud hole     d:")
	(set_tile "labeln6" "Neck O/D     A:")
	(set_tile "labeln7" "Length.         Y:")
	(set_tile "labeln8" "Kg            :")
	(set_tile "labeln9" "Bore I/D        B:")
	(set_tile "labeln10" "Face Ht.       E:")	
	);end rb11_flag

	(defun RB12_FLAG ()
	(setq flg "sw_")										;store flange type
	(set_tile "labeln1" "Flange O/D   O:")
	(set_tile "labeln2" "Flange Thk   C:")
	(set_tile "labeln3" "Face Dia.     R:")
	(set_tile "labeln4" "Stud Qty.     :")
	(set_tile "labeln5" "Stud hole     d:")
	(set_tile "labeln6" "Neck O/D     A:")
	(set_tile "labeln7" "Length.        Y:")
	(set_tile "labeln8" "Kg            :")
	(set_tile "labeln9" "Bore I/D      B:")
	(set_tile "labeln10" "Face Ht.      E:")		
	);end rb12_flag

	(defun RB13_FLAG ()
	(setq flg "so_")										;store flange type
	(set_tile "labeln1" "Flange O/D   O:")
	(set_tile "labeln2" "Flange Thk   C:")
	(set_tile "labeln3" "Face Dia.     R:")
	(set_tile "labeln4" "Stud Qty.     :")
	(set_tile "labeln5" "Stud hole     d:")
	(set_tile "labeln6" "Neck O/D     X:")
	(set_tile "labeln7" "Length.        Y:")
	(set_tile "labeln8" "Kg            :")
;	(set_tile "labeln9" "N/A:")								;"Bore I/D  B:"
	(set_tile "labeln10" "Face Ht.      E:")
	);end rb13_flag

	(defun RB14_FLAG ()
	(setq flg "scr_")										;store flange type
	(set_tile "labeln1" "Flange O/D   O:")
	(set_tile "labeln2" "Flange Thk   C:")
	(set_tile "labeln3" "Face Dia.     R:")
	(set_tile "labeln4" "Stud Qty.     :")
	(set_tile "labeln5" "Stud hole     d:")
	(set_tile "labeln6" "Neck O/D     A:")
	(set_tile "labeln7" "Length.        Y:")
	(set_tile "labeln8" "Kg            :")
;	(set_tile "labeln9" "N/A:")								;"Bore I/D  B:"
	(set_tile "labeln10" "Face Ht.      E:")
	);end rb14_flag

	(defun RB15_FLAG ()
	(setq flg "bl_")										;store flange type
	(set_tile "labeln1" "Flange O/D   O:")
	(set_tile "labeln2" "Flange Thk   C:")
	(set_tile "labeln3" "Face Dia.     R:")
	(set_tile "labeln4" "Stud Qty.     :")
	(set_tile "labeln5" "Stud hole     d:")
;	(set_tile "labeln6" "N/A:")								;"Neck O/D   X:"
;	(set_tile "labeln7" "N/A:")								;"Length.      Y:"
	(set_tile "labeln8" "Kg            :")
;	(set_tile "labeln9" "N/A:")								;"Bore I/D  B:"
	(set_tile "labeln10" "Face Ht.      E:")
	);end rb15_flag
	
	(defun RB21_FLAG ()
	(setq fce "rtj_")										;store face type
	(set_tile "labeln10" "Face Ht.      E:")
	(set_tile "labeln3" "Face Dia.     R:")
	);end rb21_flag		
	
	(defun RB22_FLAG ()
	(setq fce "rf_")										;store face type
	(set_tile "labeln10" "Face Ht.      E:")
	(set_tile "labeln3" "Face Dia.     R:")
	);end rb22_flag		
	
	(defun RB23_FLAG ()
	(setq fce "ff_")										;store face type
;	(set_tile "labeln10" "N/A:")							;"Face Ht.   E:"
;	(set_tile "labeln3" "N/A:")								;"Face Dia.  R:"
	);end rb23_flag		
	
	(defun RB31_FLAG ()
	(setq clss "#150")										;store class rating
	);end rb31_flag	  

	(defun RB32_FLAG ()
	(setq clss "#300")										;store class rating
	);end rb32_flag	

	(defun RB33_FLAG ()
	(setq clss "#400")										;store class rating
	);end rb33_flag	

	(defun RB34_FLAG ()
	(setq clss "#600")										;store class rating
	);end rb34_flag

	(defun RB35_FLAG ()
	(setq clss "#900")										;store class rating
	);end rb35_flag	

	(defun RB36_FLAG ()
	(setq clss "#1500")										;store class rating
	);end rb36_flag	

	(defun RB37_FLAG ()
	(setq clss "#2500")										;store class rating
	);end rb37_flag	

	(defun RB41_FLAG ()
	(setq sch "sch_5_")											;store schedule rating
	);end rb41_flag	

	(defun RB42_FLAG ()
	(setq sch "sch_10_")										;store schedule rating
	);end rb42_flag	

	(defun RB43_FLAG ()
	(setq sch "sch_20_")										;store schedule rating
	);end rb43_flag	

	(defun RB44_FLAG ()
	(setq sch "sch_30_")										;store schedule rating
	);end rb44_flag	

	(defun RB45_FLAG ()
	(setq sch "sch_40_")										;store schedule rating
	);end rb45_flag	

	(defun RB46_FLAG ()
	(setq sch "sch_60_")										;store schedule rating
	);end rb46_flag

	(defun RB47_FLAG ()
	(setq sch "sch_80_")									;store schedule rating
	);end rb47_flag	
	
	(defun RB48_FLAG ()
	(setq sch "sch_100_")									;store schedule rating
	);end rb48_flag		
	
	(defun RB49_FLAG ()
	(setq sch "sch_120_")									;store schedule rating
	);end rb49_flag	
		
	(defun S7_FLAG ()
	(setq sel "pipe_")										;store pipe 
;	(set_tile "labeln1" "N/A:")
	(set_tile "labeln2" "Wall Thk    :")
;	(set_tile "labeln3" "N/A:")
;	(set_tile "labeln4" "N/A:")
;	(set_tile "labeln5" "N/A:")
	(set_tile "labeln6" "Pipe O/D       :")					;"Neck O/D   X:"
;	(set_tile "labeln7" "N/A:")								;"Length.      Y:"
	(set_tile "labeln8" "Kg/mtr          :")
	(set_tile "labeln9" "Pipe I/D      :")					;"Bore I/D  B:"
;	(set_tile "labeln10" "N/A:")	
	);end s7_flag	
	
	(defun F_NAME ()
	(setq fname (strcat sel ftg flg fce sch clss ".DIM"))
	) end F_NAME
;---------------------------------------------MAIN PROGRAM----------------------------------------------------------------------;
;-------------------------------------------------------------------------------------------------------------------------------;
;-------------------------------------------------------------------------------------------------------------------------------;
(defun READ_DIM_FILE (/ A AA)
  ;Read data file and parse "size string", nth 0, for display in
  ;list box as variable display_list.				 
  (SET_NIL)
  (setq A "")
  (DEFAULTS)  
  (OPEN_DIM_FILE)
  (while (/= A NIL)
    (setq A (read-line DIM_FILE))
    (if (/= A NIL)
      (progn
        (setq
          A  (nth 0 (read A))
          AA (append AA (list A))
        ) ;_ end of setq
      ) ;end progn
    ) ;end if
  ) ;end while
  (setq DISPLAY_LIST (reverse AA))
  (close DIM_FILE)
  (start_list "get_size")
  (mapcar 'add_list DISPLAY_LIST)
  (end_list)
) ;end READ_DIM_FILE

  ;-----------------------------------------------------------------------;
(defun SET_NIL ()
  (setq
    DEF_NEWTILE NIL
    DEF_SIZE NIL
    DEF_DISPLAY_LIST NIL
    DEF_INDEX NIL
    DEF_D NIL
    SIZE NIL
    DISPLAY_LIST NIL
    INDEX NIL
    D NIL
    DEF_PIPE_OD1 NIL
    DEF_PIPE_OD2 NIL
    DEF_OD_PIPEDIM NIL
    DEF_ID_PIPEDIM NIL
    PIPE_OD1 NIL
    PIPE_OD2 NIL
  ) ;_ end of setq
  (start_list "get_size")
  (mapcar 'add_list DISPLAY_LIST)
  (end_list)
) ;end SET_NIL
 ;-----------------------------------------------------------------------;
(defun DATA_LIST (/ TEST)
  ;Read selected dwg name (size, size,) from list box and read name list from
  ;data file.
  (OPEN_DIM_FILE)
  (progn
    (while (/= SIZE TEST)
      (setq
        SIZE_DIMS (read (read-line DIM_FILE))
        TEST (strcase (nth 0 SIZE_DIMS))
      ) ;end setq
    ) ;end while
    (close DIM_FILE)
  ) ;end progn
) ;end DATA_LIST
  ;-----------------------------------------------------------------------;
(defun OPEN_DIM_FILE ()									  ;Find and open data file, *.dim
    (setq DIM_FILE (open (findfile fname) "r"))
 ) ;end OPEN_DIM_FILE		;   (princ (strcat "\nFilename after open_dim_file = " fname " "))
   ;-----------------------------------------------------------------------;
;(defun DRAW_SHAPE ()
;  (if (and (/= NEWTILE NIL))
;    (INSERT_BLOCK_VIEW)
;  ) ;_ end of if
; ) ; end DRAW_SHAPE
  ;-----------------------------------------------------------------------;
(defun SET_DIM ()
	(setvar 'dimzin 0)
    (setq
    N1 (nth 3 SIZE_DIMS)
    N2 (nth 4 SIZE_DIMS)
    N3 (nth 5 SIZE_DIMS)
    N4 (nth 6 SIZE_DIMS)
    N5 (nth 7 SIZE_DIMS)
    N6 (nth 8 SIZE_DIMS)
    N7 (nth 9 SIZE_DIMS)
    N8 (nth 10 SIZE_DIMS)
	N9 (nth 11 SIZE_DIMS)
	N10 (nth 12 SIZE_DIMS)
    ) ;end setq
;  (if (= SCALE "1")
;    (STL_SCALE_TO_E)
;  ) ;_ end of if
  (set_tile "n1" (rtos N1 2 2))
  (set_tile "n2" (rtos N2 2 2))
  (set_tile "n3" (rtos N3 2 2))
  (set_tile "n4" (rtos N4 2 2))
  (set_tile "n5" (rtos N5 2 2))
  (set_tile "n6" (rtos N6 2 2))
  (set_tile "n7" (rtos N7 2 2))
  (set_tile "n8" (rtos N8 2 1))
  (set_tile "n9" (rtos N9 2 2))  
  (set_tile "n10" (rtos N10 2 2))
  (setvar 'dimzin 8)
) ;End SET_DIM
 ;------------------------------------------------------------------------;
 (defun INSERT_BLOCK_VIEW ()
     (if (= NEWTILE "rb31")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb32")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb33")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb34")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb35")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb36")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb37")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb41")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb42")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb43")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb44")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb45")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb46")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb47")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb48")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if
    (if (= NEWTILE "rb49")
    (SET_BLOCK)			;GOTO SET BLOCK
  ) ;_ end of if	
	(if (= NEWTILE "s7")
	(DRAW_PIPE_SHAPE)
  ) ;_ end of if
 ) ;end INSERT_BLOCK_VIEW
;-------------------------------------------------------------------------;
 (defun SET_BLOCK ()
  (setq D  (nth 1 SIZE_DIMS)
  ) ;end setq
  (INSERT_BLOCK)		;GOTO INSERT BLOCK
 ) ;End SET_BLOCK
  ;-----------------------------------------------------------------------;
(defun INSERT_BLOCK ()
  ;(princ D) ; print the content of D variable to the command line.
  (if (tblsearch "block" D)
    (progn
     (command "_.insert" D pause "" "" ""))
	 (progn
      (setq dwg (strcat D ".dwg"))
      (if (setq fullPath (findfile dwg))
	(command "_.-insert" fullPath  pause "" "" "")
	(Princ (strcat "\nNot found drawing name <" dwg "> in support file search path.")) )) )
  (princ))
  ;-----------------------------------------------------------------------;
  ;for ICAD 10.0 ONWARDS ONLY
;(defun DRAW_PIPE_SHAPE ( / spt1 spt2 dis ENT1 ENT2) 	; pipod pipid
; (if (and (setq spt1 (getpoint "\nSpecify Start point of Pipe"))
;          (setq spt2 (getpoint "\nSpecify End point of Pipe"))
;     ) ;end of AND
;   (progn
;	(command "ucs" "ZA" spt1 spt2)
;	(command "circle" "0,0,0" "d" "120.00")
;	(command "circle" "0,0,0" "d" "pipod")		;take OD from dim file
;		(setq ENT1 (entlast))
;	(command "circle" "0,0,0" "d" "100.00")
;	(command "circle" "0,0,0" "d" "pipid")		;take ID from dim file
;		(setq ENT2 (entlast))
;		(setq dis (distance spt1 spt2)) 		;added from Nguyen
;   (command "extrude" ENT1 "" dis "") 			;modified from Nguyen
;		(setq ENT1 (entlast))
;    (command "extrude" ENT2 "" dis "") 			;modified from Nguyen
;		(setq ENT2 (entlast))
;   	(command "subtract" ENT1 "" ENT2 "")	
;   	(command "ucs" "_P")
;    ) ;_ end of progn
;   )  ;_ end of IF
;) ;end DRAW_PIPE_SHAPE
  ;-----------------------------------------------------------------------;
  ;for ICAD 9.0 ONLY
(defun DRAW_PIPE_SHAPE ( / spt1 spt2 ENT1 ENT2)
 (if (and (setq spt1 (getpoint "\nSpecify Start point of Pipe"))
          (setq spt2 (getpoint "\nSpecify End point of Pipe"))
     ) ;end of AND
   (progn
	(command "ucs" "ZA" spt1 spt2)
	(command "circle" "0,0,0" "d" "120.00")
		(setq ENT1 (entlast))
	(command "circle" "0,0,0" "d" "100.00")
		(setq ENT2 (entlast))
    (command "extrude" ENT1 "" "D" spt1 spt2)	
		(setq ENT1 (entlast))
    (command "extrude" ENT2 "" "D" spt1 spt2)
		(setq ENT2 (entlast))		
   	(command "subtract" ENT1 "" ENT2 "")	
   	(command "ucs" "_P")
    ) ;_ end of progn
   )  ;_ end of IF
) ;end DRAW_PIPE_SHAPE
;-------------------------------------------------------------------------;
(defun DEFAULTS () ;Set defaults
  (if (/= DEF_NEWTILE NIL)
    (setq NEWTILE DEF_NEWTILE)
  ) ;_ end of if
  (if (/= DEF_DISPLAY_LIST NIL)
    (progn
      (setq DISPLAY_LIST DEF_DISPLAY_LIST)
      (start_list "get_size")
      (mapcar 'add_list DISPLAY_LIST)
      (end_list)
    ) ;_ end of progn
  ) ;_ end of if
  (if (/= DEF_SIZE NIL)
    (setq SIZE DEF_SIZE)
  ) ;_ end of if
  (if (/= DEF_INDEX NIL)
    (setq INDEX DEF_INDEX)
  ) ;_ end of if
  (if (/= DEF_N1DIM NIL)
    (set_tile "n1" DEF_N1DIM)
  ) ;_ end of if
  (if (/= DEF_N2DIM NIL)
    (set_tile "n2" DEF_N2DIM)
  ) ;_ end of if
  (if (/= DEF_N3DIM NIL)
    (set_tile "n3" DEF_N3DIM)
  ) ;_ end of if
  (if (/= DEF_N4DIM NIL)
    (set_tile "n4" DEF_N4DIM)
  ) ;_ end of if
  (if (/= DEF_N5DIM NIL)
    (set_tile "n5" DEF_N5DIM)
  ) ;_ end of if
  (if (/= DEF_N6DIM NIL)
    (set_tile "n6" DEF_N6DIM)
  ) ;_ end of if
  (if (/= DEF_N7DIM NIL)
    (set_tile "n7" DEF_N7DIM)
  ) ;_ end of if
  (if (/= DEF_N8DIM NIL)
    (set_tile "n8" DEF_N8DIM)
  ) ;_ end of if
    (if (/= DEF_N9DIM NIL)
    (set_tile "n9" DEF_N9DIM)
  ) ;_ end of if
      (if (/= DEF_N10DIM NIL)
    (set_tile "n10" DEF_N10DIM)
  ) ;_ end of if
  (if (/= DEF_D NIL)
    (setq D DEF_D)
  ) ;_ end of if
) ;end DEFAULTS
  ;-----------------------------------------------------------------------;
(defun CHECK_SELECTIONS () ;First save defaults
  (setq
    DEF_NEWTILE NEWTILE
    DEF_SIZE SIZE
    DEF_DISPLAY_LIST DISPLAY_LIST
    DEF_INDEX INDEX
    DEF_D D
  ) ;end setq
  ;Then check selections
  (if (= NEWTILE NIL)
    (alert "OOPS! SELECT A SHAPE TYPE - TRY AGAIN!")
  ) ;_ end of if
  (if (and (/= NEWTILE NIL) (= SIZE NIL))
    (alert "OOPS! SELECT A SHAPE SIZE - TRY AGAIN!")
  ) ;_ end of if
  (if (and (/= NEWTILE NIL) (/= SIZE NIL))
    (done_dialog)
  ) ;_ end of if
) ;end CHECK_SELECTIONS
  ;-----------------------------------------------------------------------;
(defun SLN_PIPING_ABOUT ()
  (if (= SLN_PIPING_ABOUT_LIST NIL)
    (progn
      (setq LINE "")
     (setq HELPFILE (open (findfile "sln_piping_about.txt") "r"))
     (while (/= LINE NIL)
        (setq LINE (read-line HELPFILE))
        (if (/= LINE NIL)
          (setq SLN_PIPING_ABOUT_LIST (append SLN_PIPING_ABOUT_LIST (list LINE)))
        ) ;end if
      ) ;end while /= line nil
      (close HELPFILE)
    ) ;end progn
  ) ;end = sln_piping_about_list nil
  (setq DCL_ID (load_dialog (findfile "sln_piping.dcl")))
  (if (not (new_dialog "sln_piping_about" DCL_ID ""))
    (exit)
  ) ;_ end of if
  (start_list "sln_piping_about")
  (mapcar 'add_list SLN_PIPING_ABOUT_LIST)
  (end_list)
  (start_dialog)
  (unload_dialog DCL_ID)
) ;end SLN_PIPING_ABOUT
;-------------------------------------------------------------------------------------------------------------------------------;
;-------------------------------------------------------------------------------------------------------------------------------;
;---------------------------------------------MAIN DIALOGUE---------------------------------------------------------------------;
(defun DIALOG ()
  (setq DCL_ID (load_dialog "sln_piping.dcl")) ;load the DCL file
  (if (not (new_dialog "sln_piping" DCL_ID)) ;initialize the DCL file
    (exit) ;exit if this doesn't work
  ) ;end if
	(DEFAULTS)
	(RESET_LIST)
	(SET_MAIN_IMAGE)
;
;----------------------------------------------ACTION TILE STATEMENTS----------------------------------------------------------; 
;------------------------------------------------------------------------------------------------------------------------------; 
;------------------------------------------------------------------------------------------------------------------------------; 
 	(action_tile "s1"				 						;toggle Fitting options
		"(L1_ON)(L2_OFF)(L3_OFF)(L4_OFF)(L5_OFF)
		(L1_CLEAR)(L2_CLEAR)(L3_CLEAR)(L4_CLEAR)(L5_CLEAR)";
	); END ACTION TILE 
;-----------------------------------------------------------------------; 	
	(action_tile "s2"				 						;toggle Flange options 
		"(L1_OFF)(L2_ON)(L3_OFF)(L4_OFF)(L5_OFF)
		(L1_CLEAR)(L2_CLEAR)(L3_CLEAR)(L4_CLEAR)(L5_CLEAR)"
	); END ACTION TILE 
;-----------------------------------------------------------------------; 
	(action_tile "s3"				 						;toggle Ball Valve options
		"(L1_OFF)(L2_OFF)(L3_ON)(L4_OFF)(L5_OFF)
		(L1_CLEAR)(L2_CLEAR)(L3_CLEAR)(L4_CLEAR)(L5_CLEAR)";
	); END ACTION TILE 
;-----------------------------------------------------------------------; 
	(action_tile "s4"				 						;toggle Wafer Check Valve options
		"(L1_OFF)(L2_OFF)(L3_ON)(L4_OFF)(L5_OFF)
		(L1_CLEAR)(L2_CLEAR)(L3_CLEAR)(L4_CLEAR)(L5_CLEAR)";
	); END ACTION TILE 
;-----------------------------------------------------------------------; 
	(action_tile "s5"				 						;toggle Gate Valve options
		"(L1_OFF)(L2_OFF)(L3_ON)(L4_OFF)(L5_OFF)
		(L1_CLEAR)(L2_CLEAR)(L3_CLEAR)(L4_CLEAR)(L5_CLEAR)";
	); END ACTION TILE 
;-----------------------------------------------------------------------; 
	(action_tile "s6"				 						;toggle Globe Valve options
		"(L1_OFF)(L2_OFF)(L3_ON)(L4_OFF)(L5_OFF)
		(L1_CLEAR)(L2_CLEAR)(L3_CLEAR)(L4_CLEAR)(L5_CLEAR)";
	); END ACTION TILE 
;-----------------------------------------------------------------------; 
	(action_tile "s7"				 						;toggle Pipe options
	(strcat
      "(setq newtile $key)"	
		"(L1_OFF)(L2_OFF)(L3_OFF)(L4_OFF)(L5_ON)
		(L1_CLEAR)(L2_CLEAR)(L3_CLEAR)(L4_CLEAR)(L5_CLEAR)
		(S7_FLAG)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------; 
	(action_tile "get_size"
    (strcat
      "(setq index (atoi $value))"
      "(setq size (strcase (nth index display_list)))"
      "(DATA_LIST)" "(SET_DIM)"
    ) ;_ end of strcat
  ) ;_ end of action_tile
;-----------------------------------------------------------------------; 
	(action_tile "rb1"				 						;toggle LRE90 option
		"(L5_FITTINGS_ON)(RB1_FLAG)(SET_WLRE90_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb2"				 						;toggle LRE45 option
		"(L5_FITTINGS_ON)(RB2_FLAG)(SET_WLRE45_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb3"				 						;toggle ET option
		"(L5_FITTINGS_ON)(RB3_FLAG)(SET_ETEE_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb4"				 						;toggle RT option
		"(L5_FITTINGS_ON)(RB4_FLAG)(SET_RTEE_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb5"				 						;toggle CR option
		"(L5_FITTINGS_ON)(RB5_FLAG)"						;(SET_CR_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb6"				 						;toggle ER option
		"(L5_FITTINGS_ON)(RB6_FLAG)"						;"(SET_ER_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb7"				 						;toggle EC option
		"(L5_FITTINGS_ON)(RB7_FLAG)"						;"(SET_EC_IMAGE)"
	); END ACTION TILE
-----------------------------------------------------------------------;
	(action_tile "rb11"				 						;toggle WN option
		"(L3_ON)(RB11_FLAG)(SET_WNRF_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb12"				 						;toggle SW option
		"(L3_ON)(RB12_FLAG)(SET_SW1_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb13"				 						;toggle SO option
		"(L3_ON)(RB13_FLAG)(SET_SO1_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb14"				 						;toggle SCR option
		"(L3_ON)(RB14_FLAG)(SET_SO1_IMAGE)"
	); END ACTION TILE
	;-----------------------------------------------------------------------;
	(action_tile "rb15"				 						;toggle BL option
		"(L3_ON)(RB15_FLAG)(SET_BL1_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB21 TO RB 23 INC 
;-----------------------------------------------------------------------;
	(action_tile "rb21"				 						;toggle RTJ option
	"(cond ((= flg \"scr_\")
		(progn
			(L4_SCR_ON)
			(SET_SO1_IMAGE)			
			(RB21_FLAG)
		)
		)
		((= flg \"so_\")
		(progn
			(L4_SCR_ON)
			(SET_SO1_IMAGE)			
			(RB21_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L4_SW_ON)
			(SET_SW1_IMAGE)				
			(RB22_FLAG)
		)
		)
		((= flg \"bl_\")
		(progn
			(L4_ON)
			(SET_BL1_IMAGE)
			(RB23_FLAG)
		)
		)		
		(t (progn
			(L4_ON)
			(RB21_FLAG)
			(SET_WNRF_IMAGE)			
		)
		)
	)"
;		"(L4_ON)(RB21_FLAG)(SET_WNRTJ_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB21 TO RB 23 INC
;-----------------------------------------------------------------------;
	(action_tile "rb22"				 						;toggle RF option
	"(cond ((= flg \"scr_\")
		(progn
			(L4_SCR_ON)
			(SET_SO1_IMAGE)			
			(RB22_FLAG)
		)
		)
		((= flg \"so_\")
		(progn
			(L4_SCR_ON)
			(SET_SO1_IMAGE)				
			(RB22_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L4_SW_ON)
			(SET_SW1_IMAGE)				
			(RB22_FLAG)
		)
		)
		((= flg \"bl_\")
		(progn
			(L4_ON)
			(SET_BL1_IMAGE)
			(RB23_FLAG)
		)
		)
		(t (progn
			(L4_ON)
			(RB22_FLAG)
			(SET_WNRF_IMAGE)
		)
		)

	)"
;		"(L4_ON)(RB22_FLAG)(SET_WNRF_IMAGE)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB21 TO RB 23 INC
;-----------------------------------------------------------------------;
	(action_tile "rb23"				 						;toggle FF option
	"(cond 
		((= flg \"scr_\")
		(progn
			(L4_SCR_ON)
			(SET_SO2_IMAGE)
			(RB23_FLAG)
		)
		)
		((= flg \"so_\")
		(progn
			(L4_SCR_ON)
			(SET_SO2_IMAGE)
			(RB23_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L4_SW_ON)
			(SET_SW2_IMAGE)
			(RB23_FLAG)
		)
		)
		((= flg \"bl_\")
		(progn
			(L4_ON)
			(SET_BL2_IMAGE)
			(RB23_FLAG)
		)
		)
		(t (progn
			(L4_ON)
			(SET_WNFF_IMAGE)
			(RB23_FLAG)
			
		)
		)
	)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB31 TO RB 37 INC
;-----------------------------------------------------------------------;
	(action_tile "rb31"				 						;toggle #150 option
		"(cond ((= flg \"wn_\")
		(progn
			(L5_ON)
			(RB31_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L5_SW_ON)
			(RB31_FLAG)
		)
		)
		(t (progn
			(setq newtile $key)
			(RB31_FLAG)
			(F_NAME)
			(READ_DIM_FILE)
		)
		)
	)"
	); END ACTION TILE	
;-----------------------------------------------------------------------; 
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB31 TO RB 37 INC
;-----------------------------------------------------------------------; 
	(action_tile "rb32"				 						;toggle #300 option
  		"(cond ((= flg \"wn_\")
		(progn
			(L5_ON)
			(RB32_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L5_SW_ON)
			(RB32_FLAG)
		)
		)
		(t (progn
			(setq newtile $key)
			(RB32_FLAG)
			(F_NAME)
			(READ_DIM_FILE)
		)
		)
	)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB31 TO RB 37 INC	
;-----------------------------------------------------------------------; 
    (action_tile "rb33"				 						;toggle #400 option
		"(cond ((= flg \"wn_\")
		(progn
			(L5_ON)
			(RB33_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L5_SW_ON)
			(RB33_FLAG)
		)
		)
		(t (progn
			(setq newtile $key)
			(RB33_FLAG)
			(F_NAME)
			(READ_DIM_FILE)
		)
		)
	)" 
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB31 TO RB 37 INC	 
;-----------------------------------------------------------------------; 
	(action_tile "rb34"				 						;toggle #600 option	
  		"(cond ((= flg \"wn_\")
		(progn
			(L5_ON)
			(RB34_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L5_SW_ON)
			(RB34_FLAG)
		)
		)
		(t (progn
			(setq newtile $key)
			(RB34_FLAG)
			(F_NAME)
			(READ_DIM_FILE)
		)
		)
	)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB31 TO RB 37 INC	
;-----------------------------------------------------------------------; 
    (action_tile "rb35"				 						;toggle #900 option				 						;toggle #150 option
		"(cond ((= flg \"wn_\")
		(progn
			(L5_ON)
			(RB35_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L5_SW_ON)
			(RB35_FLAG)
		)
		)
		(t (progn
			(setq newtile $key)
			(RB35_FLAG)
			(F_NAME)
			(READ_DIM_FILE)
		)
		)
	)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB31 TO RB 37 INC	
;-----------------------------------------------------------------------; 
    (action_tile "rb36"				 						;toggle #1500 option
		"(cond ((= flg \"wn_\")
		(progn
			(L5_ON)
			(RB36_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L5_SW_ON)
			(RB36_FLAG)
		)
		)
		(t (progn
			(setq newtile $key)
			(RB36_FLAG)
			(F_NAME)
			(READ_DIM_FILE)
		)
		)
	)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
;COMMENTS CAN NOT BE ADDED TO CODE FOR RB31 TO RB 37 INC	
;-----------------------------------------------------------------------; 
    (action_tile "rb37"				 						;toggle #2500 option
		"(cond ((= flg \"wn_\")
		(progn
			(L5_ON)
			(RB37_FLAG)
		)
		)
		((= flg \"sw_\")
		(progn
			(L5_SW_ON)
			(RB37_FLAG)
		)
		)
		(t (progn
			(setq newtile $key)
			(RB37_FLAG)
			(F_NAME)
			(READ_DIM_FILE)
		)
		)
	)"
	); END ACTION TILE
;-----------------------------------------------------------------------;
	(action_tile "rb41"				 						;toggle SCH5 option
		(strcat
      "(setq newtile $key)"	
		"(RB41_FLAG)(F_NAME)(READ_DIM_FILE)"				;"(SET_WLRE90_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
 	(action_tile "rb42"				 						;toggle SCH10 option
		(strcat
      "(setq newtile $key)"	
	  "(RB42_FLAG)(F_NAME)(READ_DIM_FILE)"					;"(SET_WLRE90_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
  	(action_tile "rb43"				 						;toggle SCH20 option
		(strcat
      "(setq newtile $key)"		
		"(RB43_FLAG)(F_NAME)(READ_DIM_FILE)"				; "(SET_WN1_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
 	(action_tile "rb44"				 						;toggle SCH30 option
		(strcat
      "(setq newtile $key)"	
	  "(RB44_FLAG)(F_NAME)(READ_DIM_FILE)"					;"(SET_WLRE90_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
  	(action_tile "rb45"				 						;toggle SCH40 option
		(strcat
      "(setq newtile $key)"	
		"(RB45_FLAG)(F_NAME)(READ_DIM_FILE)"				;"(SET_WLRE90_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
  	(action_tile "rb46"				 						;toggle SCH60 option
		(strcat
      "(setq newtile $key)"	
		"(RB46_FLAG)(F_NAME)(READ_DIM_FILE)"				;"(SET_WLRE90_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
  	(action_tile "rb47"				 						;toggle SCH80 option
		(strcat
      "(setq newtile $key)"	
		"(RB47_FLAG)(F_NAME)(READ_DIM_FILE)"				;"(SET_WLRE90_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
  	(action_tile "rb48"				 						;toggle SCH100 option
		(strcat
      "(setq newtile $key)"	
		"(RB48_FLAG)(F_NAME)(READ_DIM_FILE)"				;"(SET_WLRE90_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
  	(action_tile "rb49"				 						;toggle SCH120 option
		(strcat
      "(setq newtile $key)"	
		"(RB49_FLAG)(F_NAME)(READ_DIM_FILE)"				;"(SET_WLRE90_IMAGE)"
		); end strcat
	); END ACTION TILE
;-----------------------------------------------------------------------;
; (defun DIALOG () continued
  
  (action_tile "accept" "(CHECK_SELECTIONS)" ); 
  
  (action_tile
    "cancel"
    (strcat "(done_dialog)" "(setq newtile nil size nil )" "(exit)")
  ) ;_ end of action_tile
   
 (action_tile "sln_piping_about" "(sln_piping_about)")
  (start_dialog)											;start dialog
  (unload_dialog dcl_id) 									;unload 
	(princ (strcat "\nFilename after unload_dialog = " sel " "))
	(princ (strcat "\nFilename after unload_dialog = " flg " "))
	(princ (strcat "\nFilename after unload_dialog = " ftg " "))
	(princ (strcat "\nFilename after unload_dialog = " fce " "))
	(princ (strcat "\nFilename after unload_dialog = " sch " "))
	(princ (strcat "\nFilename after unload_dialog = " clss " "))
	(princ (strcat "\nFilename after unload_dialog = " fname " "))
) ;end Dialogue
;	(princ)
;-----------------------------------------------------------------------------------;
;-----------------------------------------------------------------------------------;
;-----------------------------------DEFINE IMAGES-----------------------------------;
(defun SET_WNRF_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "wn-image.sld")				;display a slide
  (end_image)										;end image
) ;End SET_WNRF_IMAGE
;-----------------------------------------------------------------------;
(defun SET_WNFF_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "wn-image-ff.sld")			;display a slide
  (end_image)										;end image
) ;End SET_WNFF_IMAGE
;-----------------------------------------------------------------------;
(defun SET_SW1_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "sw-image.sld")				;display a slide
  (end_image)										;end image
) ;End SET_SW1_IMAGE
;-----------------------------------------------------------------------;
(defun SET_SW2_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "sw-image-ff.sld")			;display a slide
  (end_image)										;end image
) ;End SET_SW2_IMAGE
;-----------------------------------------------------------------------;
(defun SET_SO1_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "so-image.sld")				;display a slide
  (end_image)										;end image
) ;End SET_SO1_IMAGE
;-----------------------------------------------------------------------;
(defun SET_SO2_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "so-image-ff.sld")				;display a slide
  (end_image)										;end image
) ;End SET_SO2_IMAGE
;-----------------------------------------------------------------------;
(defun SET_BL1_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "bl-image.sld")				;display a slide
  (end_image)										;end image
) ;End SET_BL1_IMAGE
;-----------------------------------------------------------------------;
(defun SET_BL2_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "bl-image-ff.sld")			;display a slide
  (end_image)										;end image
) ;End SET_BL2_IMAGE
;-----------------------------------------------------------------------;
(defun SET_WLRE90_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "lre90.sld")			;display a slide
  (end_image)										;end image
) ;End SET_WLRE90_IMAGE
;-----------------------------------------------------------------------;
(defun SET_WLRE45_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "lre45.sld")			;display a slide
  (end_image)										;end image
) ;End SET_WLRE45_IMAGE
;-----------------------------------------------------------------------;
(defun SET_ETEE_IMAGE ()
  (setq w (dimx_tile "imagekey")   					;get image tile width
        h (dimy_tile "imagekey")    				;get image tile height
  )	;end of setq

  (start_image "imagekey")							;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "ET-IMAGE.sld")			;display a slide
  (end_image)										;end image
) ;End SET_ETEE_IMAGE
;-----------------------------------------------------------------------;
(defun SET_RTEE_IMAGE ()
  (setq w (dimx_tile "imagekey")   						;get image tile width
        h (dimy_tile "imagekey")    					;get image tile height
  )	;end of setq

  (start_image "imagekey")								;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h "RT-IMAGE.sld")					;display a slide
  (end_image)											;end image
) ;End SET_RTEE_IMAGE
;-----------------------------------------------------------------------;
(defun SET_MAIN_IMAGE ()
  (setq w (dimx_tile "imagekey")   						;get image tile width
        h (dimy_tile "imagekey")    					;get image tile height
  )	;end of setq

  (start_image "imagekey")								;start the image
  (fill_image 0 0 w h 251)
  (slide_image 0 0 w h  "Piping main image.sld")		;display a slide
  (end_image)											;end image
) ;End SET_MAIN_IMAGE
;-----------------------------------------------------------------------;
(defun C:sln_piping ( / sel flg ftg fce sch clss fname )			;define function
  (setq
    OLDERR *ERROR*
    *ERROR* ERR
  ) ;_ end of setq
  (setq OS (getvar "OSMODE"))
  (setvar "OSMODE" 111)
  (DIALOG)
  (INSERT_BLOCK_VIEW)
  (DRAW_PIPE_SHAPE)	  
  (setvar "OSMODE" OS)
  (setq *ERROR* OLDERR) ; Restore old *error* handler
  (princ)
) ;end 

  ;Print message once loaded.
(princ)


	